"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class GenePanel(ProtocolElement):
    """
    A panel of genes
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2_1 import reports as reports_6_0_2

        return {
            "org.gel.models.report.avro.GenePanel": reports_6_0_2.GenePanel,
        }

    __slots__ = [
        "panelIdentifier",
        "panelName",
        "panelVersion",
        "source",
    ]

    def __init__(
        self,
        panelIdentifier=None,
        panelName=None,
        panelVersion=None,
        source=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_0_2.GenePanel model.

        :param panelIdentifier:
            Panel name used
        :type panelIdentifier: None | str
        :param panelName:
            Panel name used
        :type panelName: None | str
        :param panelVersion:
            Panel version
        :type panelVersion: None | str
        :param source:
            source i.e, PanelApp
        :type source: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.0.2"
